/*
    Copyright (c) 1996, David Rothwell. All Rights Reserved.

    http://www.magna.com.au/~davidr     mailto:davidr@magna.com.au

    Permission to use, copy, modify, and distribute this software
    and its documentation for NON-COMMERCIAL purposes and without
    fee is hereby granted provided that this copyright notice
    appears in all copies. This software is distributed on an 'as is'
    basis without warranty.

    Release: 0.4a   11-Sep-1996

 **/

package JOP.persist ;

import  java.util.Enumeration ;

/**
    Each ObjectDefinition has one or
    more ClassDefinitions. The ClassDefinition has
    a name (the defined class) and a number
    of slots.
*/

public interface ClassDefinition
{
    /**
        Returns the classname as a String. This classname
        is the implementation class at this level in the
        inheretence graph of the object.
    */
    public String getClassName();

    /**
        Returns the SlotDefinitions for each slot defined
        in this class. The slot definitions are returned
        in the same order as they are defined in the
        .java source file
    */
    public Enumeration slots() ;
}

