/*
    Copyright (c) 1996, David Rothwell. All Rights Reserved.

    http://www.magna.com.au/~davidr     mailto:davidr@magna.com.au

    Permission to use, copy, modify, and distribute this software
    and its documentation for NON-COMMERCIAL purposes and without
    fee is hereby granted provided that this copyright notice
    appears in all copies. This software is distributed on an 'as is'
    basis without warranty.

    Release: 0.4a   11-Sep-1996

 **/

package JOP.persist.jdbc ;

import  java.sql.* ;

public class TypeHandler_Date_1 implements TypeHandler
{
    public TypeHandler_Date_1()
    {
    }

    /**
        Save the 'object' by binding it to column of the Jdbc
        statement 'stmt'. The type is one of the constants
        defined in JOP.persist.JavaTypes.
    */
    public void saveType( PreparedStatement stmt, int column, Object object ) throws SQLException
    {
        if (object == null)
        {
            stmt.setNull(column, Types.TIMESTAMP) ;
        }
        else
        {
            java.util.Date d = (java.util.Date)object ;

            Timestamp t = new Timestamp( d.getYear(), d.getMonth(), d.getDate(), d.getHours(), d.getMinutes(), d.getSeconds(), 0 ) ;

            stmt.setTimestamp( column, t) ;
        }
    }

    /**
        Read the type and return an object
    */
    public Object readType( ResultSet rs, int column ) throws SQLException
    {
        Timestamp t = rs.getTimestamp(column) ;

        if (rs.wasNull())
        {
            return null ;
        }
        else
        {
            java.util.Date d = new java.util.Date( t.getYear(), t.getMonth(), t.getDate(), t.getHours(), t.getMinutes(), t.getSeconds()) ;

            return d ;
        }
    }

    public String getDefinition()
    {
        return "datetime" ;
    }

    public String toString()
    {
        return "Date -> " + getDefinition() ;
    }
}

