/*
    Copyright (c) 1996, David Rothwell. All Rights Reserved.

    http://www.magna.com.au/~davidr     mailto:davidr@magna.com.au

    Permission to use, copy, modify, and distribute this software
    and its documentation for NON-COMMERCIAL purposes and without
    fee is hereby granted provided that this copyright notice
    appears in all copies. This software is distributed on an 'as is'
    basis without warranty.

    Release: 0.4a   11-Sep-1996

 **/

package JOP.persist.jdbc ;

import  java.sql.* ;

public class TypeHandler_Float_1 implements TypeHandler
{
    public TypeHandler_Float_1()
    {
    }

    /**
        Save the 'object' by binding it to column of the Jdbc
        statement 'stmt'. The type is one of the constants
        defined in JOP.persist.JavaTypes.
    */
    public void saveType( PreparedStatement stmt, int column, Object object ) throws SQLException
    {
        if (object == null)
        {
            stmt.setNull(column, Types.REAL) ;
        }
        else
        {
            stmt.setFloat( column, ((Float)object).floatValue()) ;
        }
    }

    /**
        Read the type and return an object
    */
    public Object readType( ResultSet rs, int column ) throws SQLException
    {
        float f = rs.getFloat(column) ;

        if (rs.wasNull())
        {
            return null ;
        }
        else
        {
            return new Float(f) ;
        }
    }

    public String getDefinition()
    {
        return "real" ;
    }

    public String toString()
    {
        return "Float -> " + getDefinition() ;
    }
}

