/*
    Copyright (c) 1996, David Rothwell. All Rights Reserved.

    http://www.magna.com.au/~davidr     mailto:davidr@magna.com.au

    Permission to use, copy, modify, and distribute this software
    and its documentation for NON-COMMERCIAL purposes and without
    fee is hereby granted provided that this copyright notice
    appears in all copies. This software is distributed on an 'as is'
    basis without warranty.

    Release: 0.4a   11-Sep-1996

 **/

package JOP.persist.jdbc ;

import  java.sql.* ;

import  JOP.persist.ObjectIdentifier ;


/**
    Redirects TYPE_OBJECT to another strategy handler
*/
public class TypeHandler_Object_1 implements TypeHandler
{
    public TypeHandler_Object_1()
    {
    }

    /**
        Save the 'object' by binding it to column of the Jdbc
        statement 'stmt'. The type is one of the constants
        defined in JOP.persist.JavaTypes.
    */
    public void saveType( PreparedStatement stmt, int column, Object object ) throws SQLException
    {
        if (object == null)
        {
            stmt.setNull(column, Types.CHAR) ;
        }
        else
        {
            ObjectIdentifier obj = (ObjectIdentifier)object ;

            stmt.setString(column, ObjectIdentifier.oid(obj.getOid())) ;
        }
    }

    /**
        Read the type and return an object
    */
    public Object readType( ResultSet rs, int column ) throws SQLException
    {
        String s = rs.getString(column) ;

        if (rs.wasNull())
        {
            return null ;
        }
        else
        {
            return new ObjectIdentifier((long)ObjectIdentifier.oid(s)) ;
        }
    }

    public String getDefinition()
    {
        return "char(19)" ;
    }

    public String toString()
    {
        return "Object -> " + getDefinition() ;
    }
}

