/*
    Copyright (c) 1996, David Rothwell. All Rights Reserved.

    http://www.magna.com.au/~davidr     mailto:davidr@magna.com.au

    Permission to use, copy, modify, and distribute this software
    and its documentation for NON-COMMERCIAL purposes and without
    fee is hereby granted provided that this copyright notice
    appears in all copies. This software is distributed on an 'as is'
    basis without warranty.

    Release: 0.4a   11-Sep-1996

 **/

package JOP.test ;

import JOP.test.PersistTest ;
import  JOP.test.TestObject0 ;

import  JOP.persist.PersistManager ;

/**
    These tests consist of 16 test programs that exercise
    the PersistManager.
    <ol>
    <li>save a simple object with several types of slots
    <li>read back and display object
    <li>object reference to other object
    <li>just like test3 but with inheritence
    <li>object reference to other object via vector
    <li>object reference other object and back again (loop)
    <li>hashtable db to object to other object etc
    <li>same as 7 with a normal hashtable
    <li>measures performance of benchmark object
    <li>tests update capability
    <li>tests ability to pre-define object id's
    <li>test RefDB
    <li>test checksum works correctly
    <li>data value regression test and readback - Native
    <li>data value regression test and readback - Persistable
    <li>named root objects
    </ol>
    </pre>
    The test mechanism consists of a driver program that
    parses the command line, instantiates the required
    PersistManager and then invokes the 'runTest()' method
    on one of the above test patterns. There are currently
    2 different driver programs.
    <p>
    To run a test type one of the following lines:
    <pre>
        java JOP.test.JdbcTest Test1 server usename password

                or

        java JOP.test.FileTest Test1 filename
    </pre>
*/

public class Test1 implements PersistTest
{
    /**
        This test gives a simple example of an object being
        streamed out.
    */
    public void runTest( PersistManager pm )
    {
        System.out.println("\n**** Save simple object ****\n");

        try {
            pm.beginWork() ;

            TestObject0 t = new TestObject0() ;

            t.setValues() ;

            System.out.println(t) ;

            long id = pm.streamOutObject( t ) ;

            System.out.println("Object saved as id = " + id ) ;

            pm.commitWork() ;

        } catch (Exception ex)
        {
            ex.printStackTrace() ;

            try {
                pm.abortWork() ;
            } catch (Exception e)
            {
                System.err.println(e.getMessage()) ;
            }
        }
    }
}




