/*
    Copyright (c) 1996, David Rothwell. All Rights Reserved.

    http://www.magna.com.au/~davidr     mailto:davidr@magna.com.au

    Permission to use, copy, modify, and distribute this software
    and its documentation for NON-COMMERCIAL purposes and without
    fee is hereby granted provided that this copyright notice
    appears in all copies. This software is distributed on an 'as is'
    basis without warranty.

    Release: 0.4a   11-Sep-1996

 **/

package JOP.test ;

import JOP.test.PersistTest ;
import  JOP.test.TestObject0 ;

import  JOP.persist.PersistManager ;
import  JOP.persist.ObjectIdentifier ;
import  JOP.util.RefDB ;

/**
    This test verifes that a RefDB can be created and
    that objects can be stored and retrieved. The
    'late' read capability means the object
    is only read when the reference is made.
*/

public class Test12 implements PersistTest
{
    /**
        Entry point called by the test harness
    */
    public void runTest( PersistManager pm )
    {
        System.out.println("\n**** RefDB test ****\n");

        try {
            // first try and read the object

            pm.beginWork() ;

            RefDB h1 = new RefDB("Hello world") ;

            long h1id = pm.streamOutObject(h1) ;

            System.out.println("RefDB saved with id = " + h1id ) ;

            pm.commitWork() ;

            System.out.println("The RefDB value is '" + h1.getObject() + "'") ;

            pm.beginWork() ;

            RefDB h2 = (RefDB)pm.streamInObject(h1id) ;

            System.out.println("New RefDB read back") ;

            if (h1.equals(h2))
            {
                throw new Exception("RefDB's should not be equal") ;
            }

            System.out.println("The RefDB value is '" + h2.getObject() + "'") ;

            pm.commitWork() ;



            pm.beginWork() ;

            RefDB h0 = new RefDB(null) ;

            long h0id = pm.streamOutObject(h0) ;

            System.out.println("NULL RefDB saved with id = " + h0id ) ;

            pm.commitWork() ;

            System.out.println("The NULL RefDB value is '" + h0.getObject() + "'") ;

            pm.beginWork() ;

            h2 = (RefDB)pm.streamInObject(h0id) ;

            System.out.println("The NULL RefDB value is '" + h2.getObject() + "'") ;

            if (h2.getObject() != null)
            {
                throw new Exception("RefDB  should be null") ;
            }

            pm.commitWork() ;

        } catch (Exception ex)
        {
            ex.printStackTrace() ;

            try {
                pm.abortWork() ;
            } catch (Exception e)
            {
                System.err.println(e.getMessage()) ;
            }
        }
    }
}




