/*
    Copyright (c) 1996, David Rothwell. All Rights Reserved.

    http://www.magna.com.au/~davidr     mailto:davidr@magna.com.au

    Permission to use, copy, modify, and distribute this software
    and its documentation for NON-COMMERCIAL purposes and without
    fee is hereby granted provided that this copyright notice
    appears in all copies. This software is distributed on an 'as is'
    basis without warranty.

    Release: 0.4a   11-Sep-1996

 **/

package JOP.test ;

import JOP.test.PersistTest ;
import  JOP.test.TestObject0 ;

import  JOP.persist.PersistManager ;
import  JOP.persist.ObjectIdentifier ;

/**
    This test illustrates the update capabilities of
    the PersistManager and the ability of the persist
    manager to avoid updates if nothing has changed.
*/

public class Test13 implements PersistTest
{
    /**
        Entry point called by the test harness
    */
    public void runTest( PersistManager pm )
    {
        System.out.println("\n**** Update and object change detection ****\n");

        try {
            // first create an object

            pm.beginWork() ;

            TestObject0 t1 = new TestObject0() ;

            t1.setValues() ;

            System.out.println("Saving TestObject0 object...") ;

            long id = pm.streamOutObject( t1 ) ;

            System.out.println("Saving TestObject0 object...(" + id + ") unmodified") ;

            pm.streamOutObject( t1 ) ;

            t1.d = new java.util.Date() ;

            System.out.println("Saving TestObject0 object...modified date") ;

            pm.streamOutObject( t1 ) ;

            System.out.println("Saving TestObject0 object...unmodified") ;

            pm.streamOutObject( t1 ) ;

            System.out.println("Saving TestObject0 object...modified string") ;

            t1.z = "Modified" ;

            pm.streamOutObject( t1 ) ;

            System.out.println("Completed TestObject0") ;

            java.util.Vector v1 = new java.util.Vector() ;

            System.out.println("Saving Vector object...") ;

            id = pm.streamOutObject( v1 ) ;

            System.out.println("Saving Vector object...(" + id + ") unmodified") ;

            pm.streamOutObject( v1 ) ;

            v1.addElement(t1) ;

            System.out.println("Saving Vector object...add TestObject0") ;

            pm.streamOutObject( v1 ) ;

            System.out.println("Saving Vector object...unmodified") ;

            pm.streamOutObject( v1 ) ;

            System.out.println("Saving Vector object...add String") ;

            v1.addElement("Hello world") ;

            pm.streamOutObject( v1 ) ;

            System.out.println("Saving Vector object...unmodified") ;

            pm.streamOutObject( v1 ) ;

            t1.z = "Modified a second time" ;

            System.out.println("Saving Vector object...modified contained object") ;

            pm.streamOutObject( v1 ) ;

            System.out.println("Completed Vector") ;

            pm.commitWork() ;

        } catch (Exception ex)
        {
            ex.printStackTrace() ;

            try {
                pm.abortWork() ;
            } catch (Exception e)
            {
                System.err.println(e.getMessage()) ;
            }
        }
    }
}
