/*
    Copyright (c) 1996, David Rothwell. All Rights Reserved.

    http://www.magna.com.au/~davidr     mailto:davidr@magna.com.au

    Permission to use, copy, modify, and distribute this software
    and its documentation for NON-COMMERCIAL purposes and without
    fee is hereby granted provided that this copyright notice
    appears in all copies. This software is distributed on an 'as is'
    basis without warranty.

    Release: 0.4a   11-Sep-1996

 **/

package JOP.test ;

import JOP.test.PersistTest ;

import  java.util.Date ;

import  JOP.persist.PersistManager ;
import  JOP.persist.ObjectIdentifier ;

/**
    This test validates that JOP can save and read min, max and null
    values for most types and can correctly traverse object references.
*/

public class Test14 implements PersistTest
{
    /**
        Entry point called by the test harness
    */
    public void runTest( PersistManager pm )
    {
        System.out.println("\n**** Data type regression test (Native) ****\n");

        try {
            //  create the test objects

            ValueTest14   inp[] = new ValueTest14[14] ;

            System.out.println("*** creating test data") ;

            for (int i = 0 ; i < inp.length ; i++)
            {
                inp[i] = new ValueTest14(i) ;
            }

            for (int i = 0 ; i < inp.length ; i++)
            {
                if (!inp[i].equals(inp[i]))
                {
                    System.out.println("Object compare error") ;
                }
            }

            long    oid[] = new long[inp.length] ;

            pm.beginWork() ;

            for (int i = 0 ; i < inp.length ; i++)
            {
                System.out.println("*** saving object " + i ) ;

                oid[i] = pm.streamOutObject( inp[i] ) ;
            }

            System.out.println("*** commit database") ;

            pm.commitWork() ;

            ValueTest14 out[] = new ValueTest14[oid.length] ;

            pm.beginWork() ;

            for (int i = 0 ; i < oid.length ; i++)
            {
                System.out.println("*** reading object " + i ) ;

                out[i] = (ValueTest14)pm.streamInObject( oid[i]) ;

                if (!inp[i].isEqual(out[i]))
                {
                    System.out.println("*** FAILED ***") ;

                    // inp[i].dump() ;

                    // System.out.println("*** FAILED READ BACK ***") ;

                    // out[i].dump() ;

                    // return ;
                }
            }

        } catch (Exception ex)
        {
            ex.printStackTrace() ;

            try {
                pm.abortWork() ;
            } catch (Exception e)
            {
                System.err.println(e.getMessage()) ;
            }
        }
    }
}

