/*
    Copyright (c) 1996, David Rothwell. All Rights Reserved.

    http://www.magna.com.au/~davidr     mailto:davidr@magna.com.au

    Permission to use, copy, modify, and distribute this software
    and its documentation for NON-COMMERCIAL purposes and without
    fee is hereby granted provided that this copyright notice
    appears in all copies. This software is distributed on an 'as is'
    basis without warranty.

    Release: 0.4a   11-Sep-1996

 **/

package JOP.test ;

import JOP.test.PersistTest ;

import  java.util.Date ;

import  JOP.persist.PersistManager ;

import  java.io.* ;

/**
    This test validates that JOP can save and read named root objects
    using the streamOutRoot() and streamInRoot() methods.
*/

public class Test16 implements PersistTest
{
    /**
        Entry point called by the test harness
    */
    public void runTest( PersistManager pm )
    {
        System.out.println("\n**** Named root objects ****\n");

        try
        {
            pm.beginWork() ;

            boolean done = false ;

            while (!done)
            {
                DataInputStream d = new DataInputStream(System.in) ;

                System.out.println() ;
                System.out.print("ready> ") ;
                System.out.flush() ;

                String l = d.readLine() ;

                if (l.equalsIgnoreCase("q"))
                {
                    done = true ;
                }
                else if (l.equalsIgnoreCase("s"))
                {
                    System.out.print("save name> ") ;
                    System.out.flush() ;

                    String name = d.readLine() ;

                    TestObject0 t = new TestObject0() ;

                    t.z = "The name is '" + name + "'" ;

                    pm.streamOutRoot(name, t ) ;

                    System.out.println("Saved as '" + name + "'") ;
                }
                else if (l.equalsIgnoreCase("r"))
                {
                    System.out.print("read name> ") ;
                    System.out.flush() ;

                    String name = d.readLine() ;

                    try
                    {
                        TestObject0 t = (TestObject0)pm.streamInRoot( name ) ;

                        System.out.println("Read '" + name + "' = " + t ) ;
                    } catch (JOP.persist.ObjectNotFoundException ex)
                    {
                        System.out.println("Read '" + name + "'  NOT FOUND") ;
                    }
                }
                else
                {
                    System.out.println("q = quit, s = save, r = read") ;
                }
            }

            pm.commitWork() ;

        } catch (Exception ex)
        {
            ex.printStackTrace() ;

            try {
                pm.abortWork() ;
            } catch (Exception e)
            {
                System.err.println(e.getMessage()) ;
            }
        }
    }
}



