/*
    Copyright (c) 1996, David Rothwell. All Rights Reserved.

    http://www.magna.com.au/~davidr     mailto:davidr@magna.com.au

    Permission to use, copy, modify, and distribute this software
    and its documentation for NON-COMMERCIAL purposes and without
    fee is hereby granted provided that this copyright notice
    appears in all copies. This software is distributed on an 'as is'
    basis without warranty.

    Release: 0.4a   11-Sep-1996

 **/

package JOP.test ;

import JOP.test.PersistTest ;

import  JOP.test.TestObject1 ;

import  JOP.persist.PersistManager ;

/**
    This test gives a simple example that references
    another object being streamed out.
*/


public class Test3 implements PersistTest
{
    /**
        Entry point called by the test harness
    */
    public void runTest( PersistManager pm )
    {
        System.out.println("\n**** Simple object with references ****\n");

        try {
            pm.beginWork() ;

            TestObject1 t = new TestObject1() ;

            t.setValues() ;

            System.out.println(t) ;

            long id = pm.streamOutObject( t ) ;

            System.out.println("Object saved as id = " + id ) ;

            pm.commitWork() ;
        } catch (Exception ex)
        {
            ex.printStackTrace() ;

            try {
                pm.abortWork() ;
            } catch (Exception e)
            {
                System.err.println(e.getMessage()) ;
            }
        }
    }
}


