/*
    Copyright (c) 1996, David Rothwell. All Rights Reserved.

    http://www.magna.com.au/~davidr     mailto:davidr@magna.com.au

    Permission to use, copy, modify, and distribute this software
    and its documentation for NON-COMMERCIAL purposes and without
    fee is hereby granted provided that this copyright notice
    appears in all copies. This software is distributed on an 'as is'
    basis without warranty.

    Release: 0.4a   11-Sep-1996

 **/

package JOP.test ;

import JOP.test.PersistTest ;

import  JOP.test.TestObject4 ;
import  JOP.test.TestObject3 ;
import  JOP.test.TestObject2 ;

import  JOP.persist.PersistManager ;

/**
    This test references another object via a vector
*/

public class Test5 implements PersistTest
{
    /**
        Entry point called by the test harness
    */
    public void runTest( PersistManager pm )
    {
        System.out.println("\n**** Object with reference via Vector ****\n");

        try {
            pm.beginWork() ;

            TestObject4 t = new TestObject4() ;

            TestObject2 t1 = new TestObject2("obj 1") ;

            t.addReference( t1 ) ;

            TestObject2 t2 = new TestObject2("obj 2") ;

            t.addReference( t2 ) ;

            TestObject3 t3 = new TestObject3() ;

            t3.setValues() ;

            t.addReference( t3 ) ;

            t.addReference("Just a string") ;

            t.addReference(new Integer(1001)) ;

            System.out.println(t) ;

            long id = pm.streamOutObject( t ) ;

            System.out.println("Object saved as id = " + id ) ;

            pm.commitWork() ;
        } catch (Exception ex)
        {
            ex.printStackTrace() ;

            try {
                pm.abortWork() ;
            } catch (Exception e)
            {
                System.err.println(e.getMessage()) ;
            }
        }
    }
}
