/*
    Copyright (c) 1996, David Rothwell. All Rights Reserved.

    http://www.magna.com.au/~davidr     mailto:davidr@magna.com.au

    Permission to use, copy, modify, and distribute this software
    and its documentation for NON-COMMERCIAL purposes and without
    fee is hereby granted provided that this copyright notice
    appears in all copies. This software is distributed on an 'as is'
    basis without warranty.

    Release: 0.4a   11-Sep-1996

 **/

package JOP.test ;

import JOP.test.PersistTest ;

import  JOP.test.TestObject4 ;

import  JOP.persist.PersistManager ;

/**
    This test creates an object loop
*/

public class Test6 implements PersistTest
{
    /**
        Entry point called by the test harness
    */
    public void runTest( PersistManager pm )
    {
        System.out.println("\n**** Object with references in a cycle ****\n");

        try {
            pm.beginWork() ;

            TestObject4 t1 = new TestObject4() ;
            TestObject4 t2 = new TestObject4() ;

            t1.addReference( t2 ) ;
            t2.addReference( t1 ) ;

            System.out.println(t1) ;

            long id = pm.streamOutObject( t1 ) ;

            System.out.println("Object saved as id = " + id ) ;

            pm.commitWork() ;
        } catch (Exception ex)
        {
            ex.printStackTrace() ;

            try {
                pm.abortWork() ;
            } catch (Exception e)
            {
                System.err.println(e.getMessage()) ;
            }
        }
    }
}
