/*
    Copyright (c) 1996, David Rothwell. All Rights Reserved.

    http://www.magna.com.au/~davidr     mailto:davidr@magna.com.au

    Permission to use, copy, modify, and distribute this software
    and its documentation for NON-COMMERCIAL purposes and without
    fee is hereby granted provided that this copyright notice
    appears in all copies. This software is distributed on an 'as is'
    basis without warranty.

    Release: 0.4a   11-Sep-1996

 **/

package JOP.test ;

import JOP.test.PersistTest ;

import JOP.test.TestObject4 ;

import  JOP.persist.PersistManager ;
import  java.util.Hashtable ;

/**
    This test creates a normal Java hashtable.
*/

public class Test8 implements PersistTest
{
    /**
        Entry point called by the test harness
    */
    public void runTest( PersistManager pm )
    {
        System.out.println("\n**** Hashtable test ****\n");

        try {
            pm.beginWork() ;

            Hashtable ht = new Hashtable() ;

            TestObject4 t1 = new TestObject4();
            t1.setValues() ;
            t1.addReference("This is key1") ;

            ht.put("Key1", t1 ) ;
            ht.put("Key2", "Hi there") ;

            Hashtable ht2 = new Hashtable() ;

            ht2.put("SubKey1", "This is sub key 1") ;
            ht2.put("SubKey2", new Integer(1234)) ;

            ht.put("Key3", ht2 ) ;

            System.out.println(ht) ;

            long id = pm.streamOutObject( ht ) ;

            System.out.println("Object saved as id = " + id ) ;

            pm.commitWork() ;
        } catch (Exception ex)
        {
            ex.printStackTrace() ;

            try {
                pm.abortWork() ;
            } catch (Exception e)
            {
                System.err.println(e.getMessage()) ;
            }
        }
    }
}
