/*
    Copyright (c) 1996, David Rothwell. All Rights Reserved.

    http://www.magna.com.au/~davidr     mailto:davidr@magna.com.au

    Permission to use, copy, modify, and distribute this software
    and its documentation for NON-COMMERCIAL purposes and without
    fee is hereby granted provided that this copyright notice
    appears in all copies. This software is distributed on an 'as is'
    basis without warranty.

    Release: 0.4a   11-Sep-1996

 **/

package JOP.test ;

import JOP.test.PersistTest ;
import  JOP.test.TestObject0 ;

import  JOP.persist.PersistManager ;

/**
    This test provides timing for a simple example of an object being
    streamed out.
*/

public class Test9 implements PersistTest
{
    /**
        Entry point called by the test harness
    */
    public void runTest( PersistManager pm )
    {
        System.out.println("\n**** Database access timing ****\n");

        try {

            long    time = System.currentTimeMillis() ;

            long    id[] = new long[10] ;

            pm.beginWork() ;

            for (int i = 0 ; i < id.length ; i++)
            {
                TestObject0 t = new TestObject0() ;

                t.setValues() ;

                id[i] = pm.streamOutObject( t ) ;
            }

            pm.commitWork() ;

            System.out.println("StreamOut - each object took " + (System.currentTimeMillis() - time) / id.length + " ms " ) ;

            pm.beginWork() ;

            time = System.currentTimeMillis() ;

            for (int i = 0 ; i < id.length ; i++)
            {
                TestObject0 t = (TestObject0)pm.streamInObject( id[i] ) ;
            }

            System.out.println("StreamIn - each object took " + (System.currentTimeMillis() - time) / id.length + " ms " ) ;

            time = System.currentTimeMillis() ;

            for (int i = 0 ; i < id.length ; i++)
            {
                TestObject0 t = (TestObject0)pm.streamInObject( id[i] ) ;
            }

            System.out.println("StreamIn - from cache each object took " + (System.currentTimeMillis() - time) / id.length + " ms " ) ;

            pm.commitWork() ;

        } catch (Exception ex)
        {
            ex.printStackTrace() ;

            try {
                pm.abortWork() ;
            } catch (Exception e)
            {
                System.err.println(e.getMessage()) ;
            }
        }
    }
}




