/*
    Copyright (c) 1996, David Rothwell. All Rights Reserved.

    http://www.magna.com.au/~davidr     mailto:davidr@magna.com.au

    Permission to use, copy, modify, and distribute this software
    and its documentation for NON-COMMERCIAL purposes and without
    fee is hereby granted provided that this copyright notice
    appears in all copies. This software is distributed on an 'as is'
    basis without warranty.

    Release: 0.4a   11-Sep-1996

 **/

package JOP.test ;

import  JOP.persist.Persistable ;
import  JOP.persist.PersistController ;
import  JOP.persist.PersistException ;

/**
    Simple test object that contains a reference to another
    object.
*/

public class TestObject1 implements Persistable
{
    private int         i ;
    private Integer     j ;
    private long        k ;
    private Long        l ;
    private String      z ;
    private boolean     u ;
    private Boolean     v ;
    private float       e ;
    private Float       f ;
    private double      g ;
    private Double      h ;
    private short       s ;
    private byte        b ;
    private char        x ;
    private Character   y ;
    private TestObject2 t ;

    public void setValues()
    {
        i = 1 ;
        j = new Integer(2) ;
        k = 3 ;
        l = new Long(3) ;
        z = "4" ;
        u = true ;
        v = new Boolean(true) ;
        e = (float)5.5 ;
        f = new Float(6.6) ;
        g = 7.7 ;
        h = new Double(8.8) ;
        s = 9 ;
        b = 10 ;
        x = 'k' ;
        y = new Character('l') ;
        t = new TestObject2("Hello world") ;
    }

    public String toString()
    {
        return super.toString() + " [" + i + ", " + j + ", " + k + ", " + l + ", " + z + ", " +
                     u + ", " + v + ", " + e + ", " + f + ", " + g + ", " +
                     h + ", " + s + ", " + b + ", " + x + ", " + y + ", " + t + "]" ;
    }

    public void defineObject( PersistController c ) throws Exception
    {
        c.defineSlot( "JOP.test.TestObject1", "i", PersistController.TYPE_INTEGER ) ;
        c.defineSlot( "JOP.test.TestObject1", "j", PersistController.TYPE_INTEGER ) ;
        c.defineSlot( "JOP.test.TestObject1", "k", PersistController.TYPE_LONG ) ;
        c.defineSlot( "JOP.test.TestObject1", "l", PersistController.TYPE_LONG ) ;
        c.defineSlot( "JOP.test.TestObject1", "u", PersistController.TYPE_BOOLEAN ) ;
        c.defineSlot( "JOP.test.TestObject1", "v", PersistController.TYPE_BOOLEAN ) ;
        c.defineSlot( "JOP.test.TestObject1", "z", PersistController.TYPE_STRING ) ;
        c.defineSlot( "JOP.test.TestObject1", "e", PersistController.TYPE_FLOAT ) ;
        c.defineSlot( "JOP.test.TestObject1", "f", PersistController.TYPE_FLOAT ) ;
        c.defineSlot( "JOP.test.TestObject1", "g", PersistController.TYPE_DOUBLE ) ;
        c.defineSlot( "JOP.test.TestObject1", "h", PersistController.TYPE_DOUBLE ) ;
        c.defineSlot( "JOP.test.TestObject1", "s", PersistController.TYPE_SHORT ) ;
        c.defineSlot( "JOP.test.TestObject1", "b", PersistController.TYPE_BYTE ) ;
        c.defineSlot( "JOP.test.TestObject1", "x", PersistController.TYPE_CHARACTER ) ;
        c.defineSlot( "JOP.test.TestObject1", "y", PersistController.TYPE_CHARACTER ) ;
        c.defineSlot( "JOP.test.TestObject1", "t", PersistController.TYPE_OBJECT ) ;
    }

    /**
        now requires 'throws exception' because of the nested object
    */

    public void streamIn( PersistController c ) throws Exception
    {

        i = c.intValue("i");
        j = c.getInteger("j");
        k = c.longValue("k");
        l = c.getLong("l");
        z = c.getString("z") ;
        u = c.booleanValue("u");
        v = c.getBoolean("v");
        e = c.floatValue("e");
        f = c.getFloat("f");
        g = c.doubleValue("g");
        h = c.getDouble("h");
        s = c.shortValue("s");
        b = c.byteValue("b");
        x = c.charValue("x");
        y = c.getCharacter("y");
        t = (JOP.test.TestObject2)c.getObject("t");
    }

    /**
        now requires 'throws exception' because of the nested object
    */

    public void streamOut( PersistController c ) throws Exception
    {
        c.put("i", i) ;
        c.put("j", j) ;
        c.put("k", k) ;
        c.put("l", l) ;
        c.put("z", z) ;
        c.put("u", u) ;
        c.put("v", v) ;
        c.put("e", e) ;
        c.put("f", f) ;
        c.put("g", g) ;
        c.put("h", h) ;
        c.put("s", s) ;
        c.put("b", b) ;
        c.put("x", x) ;
        c.put("y", y) ;
        c.put("t", t) ;
    }
}

