/*
    Copyright (c) 1996, David Rothwell. All Rights Reserved.

    http://www.magna.com.au/~davidr     mailto:davidr@magna.com.au

    Permission to use, copy, modify, and distribute this software
    and its documentation for NON-COMMERCIAL purposes and without
    fee is hereby granted provided that this copyright notice
    appears in all copies. This software is distributed on an 'as is'
    basis without warranty.

    Release: 0.4a   11-Sep-1996

 **/

package JOP.test ;

import  JOP.persist.Persistable ;
import  JOP.persist.PersistController ;
import  JOP.persist.PersistException ;

/**
    Simple test object that is referenced by the first
    test object. We'll just store a string in here for
    now...
*/

public class TestObject2 // implements Persistable
{
    private String      z ;

    /**
        Remember must have a null constructor !!
    */

    public TestObject2()
    {
        z = "" ;
    }

    public TestObject2(String s)
    {
        z = s ;
    }

    public String toString()
    {
        return super.toString() + " [" + z + "]" ;
    }

    public void defineObject( PersistController c ) throws Exception
    {
        c.defineSlot( "JOP.test.TestObject2", "z", PersistController.TYPE_STRING ) ;
    }

    public void streamIn( PersistController c ) throws Exception
    {
        z = c.getString("z") ;
    }

    public void streamOut( PersistController c ) throws Exception
    {
        c.put("z", z) ;
    }
}

