/*
    Copyright (c) 1996, David Rothwell. All Rights Reserved.

    http://www.magna.com.au/~davidr     mailto:davidr@magna.com.au

    Permission to use, copy, modify, and distribute this software
    and its documentation for NON-COMMERCIAL purposes and without
    fee is hereby granted provided that this copyright notice
    appears in all copies. This software is distributed on an 'as is'
    basis without warranty.

    Release: 0.4a   11-Sep-1996

 **/

package JOP.test ;

import  JOP.persist.Persistable ;
import  JOP.persist.PersistController ;
import  JOP.persist.PersistException ;

/**
    Simple test object that contains a reference to another
    object.

    Just like TestObject1 except that we'll inherit from
    TestObject as a comparison.
*/

public class TestObject3 extends TestObject0 implements Persistable
{
    private TestObject2 t ;

    public void setValues()
    {
        super.setValues() ;

        t = new TestObject2("Hello worldly folks") ;
    }

    public String toString()
    {
        return super.toString() + " [" + t + "]" ;
    }

    public void defineObject( PersistController c ) throws Exception
    {
        super.defineObject(c) ;

        c.defineSlot( "JOP.test.TestObject3", "t", PersistController.TYPE_OBJECT ) ;
    }

    /**
        now requires 'throws exception' because of the nested object
    */

    public void streamIn( PersistController c ) throws Exception
    {
        super.streamIn(c) ;

        t = (TestObject2)c.getObject("t");
    }

    /**
        now requires 'throws exception' because of the nested object
    */

    public void streamOut( PersistController c ) throws Exception
    {
        super.streamOut(c) ;

        c.put("t", t) ;
    }
}

