/*
    Copyright (c) 1996, David Rothwell. All Rights Reserved.

    http://www.magna.com.au/~davidr     mailto:davidr@magna.com.au

    Permission to use, copy, modify, and distribute this software
    and its documentation for NON-COMMERCIAL purposes and without
    fee is hereby granted provided that this copyright notice
    appears in all copies. This software is distributed on an 'as is'
    basis without warranty.

    Release: 0.4a   11-Sep-1996

 **/

package JOP.test ;

import JOP.test.PersistTest ;

import  java.util.Date ;

import  JOP.persist.Persistable ;
import  JOP.persist.PersistController ;

public class ValueTest15 implements Persistable
{
    private byte    b1 ;
    private short   s1 ;
    private int     i1 ;
    private long    j1 ;
    private boolean z1 ;
    private float   f1 ;
    private double  d1 ;
    private char    c1 ;
    private byte    b2[] ;
    private short   s2[] ;
    private int     i2[] ;
    private long    j2[] ;
    private boolean z2[] ;
    private float   f2[] ;
    private double  d2[] ;
    private char    c2[] ;

    private Integer     lInteger1 ;
    private Long        lLong1 ;
    private Boolean     lBoolean1 ;
    private Float       lFloat1 ;
    private Double      lDouble1 ;
    private Character   lCharacter1 ;
    private String      lString1 ;
    private Date        lDate1 ;

    private Integer     lInteger2[] ;
    private Long        lLong2[] ;
    private Boolean     lBoolean2[] ;
    private Float       lFloat2[] ;
    private Double      lDouble2[] ;
    private Character   lCharacter2[] ;
    private String      lString2[] ;
    private Date        lDate2[] ;

    ValueTest15           object1 ;
    ValueTest15           object2[] ;

    public void defineObject( PersistController c ) throws Exception
    {
        c.defineSlot(getClass().getName(), "b1", PersistController.TYPE_BYTE ) ;
        c.defineSlot(getClass().getName(), "s1", PersistController.TYPE_SHORT ) ;
        c.defineSlot(getClass().getName(), "i1", PersistController.TYPE_INTEGER ) ;
        c.defineSlot(getClass().getName(), "j1", PersistController.TYPE_LONG ) ;
        c.defineSlot(getClass().getName(), "z1", PersistController.TYPE_BOOLEAN ) ;
        c.defineSlot(getClass().getName(), "f1", PersistController.TYPE_FLOAT ) ;
        c.defineSlot(getClass().getName(), "d1", PersistController.TYPE_DOUBLE ) ;
        c.defineSlot(getClass().getName(), "c1", PersistController.TYPE_CHARACTER ) ;

        c.defineSlotArray(getClass().getName(), "b2", PersistController.TYPE_BYTE ) ;
        c.defineSlotArray(getClass().getName(), "s2", PersistController.TYPE_SHORT ) ;
        c.defineSlotArray(getClass().getName(), "i2", PersistController.TYPE_INTEGER ) ;
        c.defineSlotArray(getClass().getName(), "j2", PersistController.TYPE_LONG ) ;
        c.defineSlotArray(getClass().getName(), "z2", PersistController.TYPE_BOOLEAN ) ;
        c.defineSlotArray(getClass().getName(), "f2", PersistController.TYPE_FLOAT ) ;
        c.defineSlotArray(getClass().getName(), "d2", PersistController.TYPE_DOUBLE ) ;
        c.defineSlotArray(getClass().getName(), "c2", PersistController.TYPE_CHARACTER ) ;

        c.defineSlot(getClass().getName(), "lInteger1", PersistController.TYPE_INTEGER ) ;
        c.defineSlot(getClass().getName(), "lLong1", PersistController.TYPE_LONG ) ;
        c.defineSlot(getClass().getName(), "lBoolean1", PersistController.TYPE_BOOLEAN ) ;
        c.defineSlot(getClass().getName(), "lFloat1", PersistController.TYPE_FLOAT ) ;
        c.defineSlot(getClass().getName(), "lDouble1", PersistController.TYPE_DOUBLE ) ;
        c.defineSlot(getClass().getName(), "lCharacter1", PersistController.TYPE_CHARACTER ) ;
        c.defineSlot(getClass().getName(), "lString1", PersistController.TYPE_STRING ) ;
        c.defineSlot(getClass().getName(), "lDate1", PersistController.TYPE_DATE ) ;

        c.defineSlotArray(getClass().getName(), "lInteger2", PersistController.TYPE_INTEGER ) ;
        c.defineSlotArray(getClass().getName(), "lLong2", PersistController.TYPE_LONG ) ;
        c.defineSlotArray(getClass().getName(), "lBoolean2", PersistController.TYPE_BOOLEAN ) ;
        c.defineSlotArray(getClass().getName(), "lFloat2", PersistController.TYPE_FLOAT ) ;
        c.defineSlotArray(getClass().getName(), "lDouble2", PersistController.TYPE_DOUBLE ) ;
        c.defineSlotArray(getClass().getName(), "lCharacter2", PersistController.TYPE_CHARACTER ) ;
        c.defineSlotArray(getClass().getName(), "lString2", PersistController.TYPE_STRING ) ;
        c.defineSlotArray(getClass().getName(), "lDate2", PersistController.TYPE_DATE ) ;

        c.defineSlot(getClass().getName(), "object1", PersistController.TYPE_OBJECT ) ;

        c.defineSlotArray(getClass().getName(), "object2", PersistController.TYPE_OBJECT ) ;
    }

    public void streamOut( PersistController c ) throws Exception
    {
        c.put( "b1", b1 ) ;
        c.put( "s1", s1 ) ;
        c.put( "i1", i1 ) ;
        c.put( "j1", j1 ) ;
        c.put( "z1", z1 ) ;
        c.put( "f1", f1 ) ;
        c.put( "d1", d1 ) ;
        c.put( "c1", c1 ) ;

        c.put( "b2", b2 ) ;
        c.put( "s2", s2 ) ;
        c.put( "i2", i2 ) ;
        c.put( "j2", j2 ) ;
        c.put( "z2", z2 ) ;
        c.put( "f2", f2 ) ;
        c.put( "d2", d2 ) ;
        c.put( "c2", c2 ) ;

        c.put( "lInteger1", lInteger1 ) ;
        c.put( "lLong1", lLong1 ) ;
        c.put( "lBoolean1", lBoolean1 ) ;
        c.put( "lFloat1", lFloat1 ) ;
        c.put( "lDouble1", lDouble1 ) ;
        c.put( "lCharacter1", lCharacter1 ) ;
        c.put( "lString1", lString1 ) ;
        c.put( "lDate1", lDate1 ) ;

        c.put( "lInteger2", lInteger2 ) ;
        c.put( "lLong2", lLong2 ) ;
        c.put( "lBoolean2", lBoolean2 ) ;
        c.put( "lFloat2", lFloat2 ) ;
        c.put( "lDouble2", lDouble2 ) ;
        c.put( "lCharacter2", lCharacter2 ) ;
        c.put( "lString2", lString2 ) ;
        c.put( "lDate2", lDate2 ) ;

        c.put( "object1", object1 ) ;
        c.put( "object2", object2 ) ;
    }

    public void streamIn( PersistController c ) throws Exception
    {
        b1 = c.byteValue( "b1" ) ;
        s1 = c.shortValue( "s1" ) ;
        i1 = c.intValue( "i1" ) ;
        j1 = c.longValue( "j1" ) ;
        z1 = c.booleanValue( "z1" ) ;
        f1 = c.floatValue( "f1" ) ;
        d1 = c.doubleValue( "d1" ) ;
        c1 = c.charValue( "c1" ) ;


        b2 = c.byteArray( "b2" ) ;
        s2 = c.shortArray( "s2" ) ;
        i2 = c.intArray( "i2" ) ;
        j2 = c.longArray( "j2" ) ;
        z2 = c.booleanArray( "z2" ) ;
        f2 = c.floatArray( "f2" ) ;
        d2 = c.doubleArray( "d2" ) ;
        c2 = c.charArray( "c2" ) ;

        lInteger1 = c.getInteger( "lInteger1") ;
        lLong1 = c.getLong( "lLong1" ) ;
        lBoolean1 = c.getBoolean( "lBoolean1" ) ;
        lFloat1 = c.getFloat( "lFloat1") ;
        lDouble1 = c.getDouble( "lDouble1" ) ;
        lCharacter1 = c.getCharacter( "lCharacter1" ) ;
        lString1 = c.getString( "lString1" ) ;
        lDate1 = c.getDate( "lDate1" ) ;

        lInteger2 = c.getIntegerArray("lInteger2") ;
        lLong2 = c.getLongArray( "lLong2" ) ;
        lBoolean2 = c.getBooleanArray( "lBoolean2" ) ;
        lFloat2 = c.getFloatArray( "lFloat2") ;
        lDouble2 = c.getDoubleArray( "lDouble2" ) ;
        lCharacter2 = c.getCharacterArray( "lCharacter2" ) ;
        lString2 = c.getStringArray( "lString2" ) ;
        lDate2 = c.getDateArray( "lDate2" ) ;

        object1 = (ValueTest15)c.getObject( "object1" ) ;

        /*
            The following code fragment illustrates the handling of arrays
            of objects. Java does not allow arrays to be cast so a new array
            must be created and each element of the returned array must
            be individually cast to the correct type.
        */

        Object obj[] = c.getObjectArray( "object2" ) ;

        if (obj == null)
        {
            object2 = null ;
        }
        else
        {
            object2 = new ValueTest15[obj.length] ;

            for (int i = 0 ; i < obj.length ; i++)
            {
                object2[i] = (ValueTest15)obj[i] ;
            }
        }
    }


    public void dump()
    {
        System.out.println("b1 = " + b1 ) ;
        System.out.println("s1 = " + s1 ) ;
        System.out.println("i1 = " + i1 ) ;
        System.out.println("j1 = " + j1 ) ;
        System.out.println("z1 = " + z1 ) ;
        System.out.println("f1 = " + f1 ) ;
        System.out.println("d1 = " + d1 ) ;
        System.out.println("c1 = " + c1 ) ;

        System.out.println("Integer = " + lInteger1 ) ;
        System.out.println("Long = " + lLong1 ) ;
        System.out.println("Boolean = " + lBoolean1 ) ;
        System.out.println("Float = " + lFloat1 ) ;
        System.out.println("Double = " + lDouble1 ) ;
        System.out.println("Character = " + lCharacter1 ) ;
        System.out.println("String = " + lString1 ) ;
        System.out.println("Date = " + lDate1 ) ;
    }

    public ValueTest15()
    {
    }

    public ValueTest15(int type)
    {
        if (type == 0)
        {
            //  minimums, no arrays, no nested objects

            setMinimum() ;
        }
        else if (type == 1)
        {
            // maximums

            setMaximum() ;
        }
        else if (type == 2)
        {
            // zero

            setZero() ;
        }
        else if (type == 3)
        {
            // null values, no arrays, no nested objectsd

            setNull() ;
        }
        else if (type == 4)
        {
            //  zero object plus zero length array

            setZero() ;
            setMinimumArray(0) ;
        }
        else if (type == 5)
        {
            //  zero object plus one length array minimums

            setZero() ;
            setMinimumArray(1) ;
        }
        else if (type == 6)
        {
            //  zero object plus one length array maximums

            setZero() ;
            setMaximumArray(1) ;
        }
        else if (type == 7)
        {
            //  zero object plus one length array null

            setZero() ;
            setNullArray(1) ;
        }
        else if (type == 8)
        {
            //  zero object plus 99 length array minimum

            setZero() ;
            setMinimumArray(9) ;
        }
        else if (type == 9)
        {
            //  zero object plus one length array plus single reference

            setZero() ;
            setMinimumArray(1) ;
            object1 = new ValueTest15(5) ;
        }
        else if (type == 10)
        {
            //  zero object plus one length array plus zero array reference

            setZero() ;
            setMinimumArray(1) ;

            object2 = new ValueTest15[0] ;
        }
        else if (type == 11)
        {
            //  zero object plus one length array plus one length array reference

            setZero() ;
            setMinimumArray(1) ;

            object2 = new ValueTest15[1] ;

            object2[0] = new ValueTest15(5) ;
        }
        else if (type == 12)
        {
            //  zero object plus one length array plus 9 length array reference

            setZero() ;
            setMinimumArray(9) ;

            object2 = new ValueTest15[9] ;

            for (int i = 0 ; i < 9 ; i++)
            {
                object2[i] = new ValueTest15( i ) ;
            }
        }
        else if (type == 13)
        {
            //  zero object plus one length array declared but not initialised

            setZero() ;
            declareArray(1) ;
        }
    }

    boolean isEqual( ValueTest15 t )
    {
        if (b1 != t.b1)
        {
            System.out.println("b1 error (" + b1 + " " + t.b1 + ")") ;
            return false ;
        }

        if (s1 != t.s1)
        {
            System.out.println("s1 error") ;
            return false ;
        }

        if (i1 != t.i1)
        {
            System.out.println("i1 error") ;
            return false ;
        }

        if (j1 != t.j1)
        {
            System.out.println("j1 error") ;
            return false ;
        }

        if (z1 != t.z1)
        {
            System.out.println("z1 error") ;
            return false ;
        }

        if (f1 != t.f1)
        {
            System.out.println("f1 error") ;
            return false ;
        }

        if (d1 != t.d1)
        {
            System.out.println("d1 error") ;
            return false ;
        }

        if (c1 != t.c1)
        {
            System.out.println("c1 error") ;
            return false ;
        }


        if (b2 != null)
        {
            if (t.b2 == null)
            {
                System.out.println("b2[] is null (" + b2 + " " + t.b2 + ")") ;

                return false ;
            }

            if (b2.length != t.b2.length)
            {
                System.out.println("b2.length error") ;
                return false ;
            }

            for (int i = 0 ; i < b2.length ; i++)
            {
                if (b2[i] != t.b2[i])
                {
                    System.out.println("b2[] error") ;
                    return false ;
                }
            }
        }
        else
        {
            if (t.b2 != null)
            {
                System.out.println("b2[] is not null") ;
                return false ;
            }
        }


        if (s2 != null)
        {
            if (t.s2 == null)
            {
                System.out.println("s2[] is null") ;
                return false ;
            }

            if (s2.length != t.s2.length)
            {
                System.out.println("s2.length error") ;
                return false ;
            }

            for (int i = 0 ; i < s2.length ; i++)
            {
                if (s2[i] != t.s2[i])
                {
                    System.out.println("s2[] error") ;
                    return false ;
                }
            }
        }
        else
        {
            if (t.s2 != null)
            {
                System.out.println("s2[] is not null") ;
                return false ;
            }
        }

        if (i2 != null)
        {
            if (t.i2 == null)
            {
                System.out.println("i2[] is null") ;
                return false ;
            }

            if (i2.length != t.i2.length)
            {
                System.out.println("i2.length error") ;
                return false ;
            }

            for (int i = 0 ; i < i2.length ; i++)
            {
                if (i2[i] != t.i2[i])
                {
                    System.out.println("i2[] error") ;
                    return false ;
                }
            }
        }
        else
        {
            if (t.i2 != null)
            {
                System.out.println("i2[] is not null") ;
                return false ;
            }
        }

        if (j2 != null)
        {
            if (t.j2 == null)
            {
                System.out.println("j2[] is null") ;
                return false ;
            }

            if (j2.length != t.j2.length)
            {
                System.out.println("j2.length error") ;
                return false ;
            }


            for (int i = 0 ; i < j2.length ; i++)
            {
                if (j2[i] != t.j2[i])
                {
                    System.out.println("j2[] error") ;
                    return false ;
                }
            }
        }
        else
        {
            if (t.j2 != null)
            {
                System.out.println("j2[] is not null") ;
                return false ;
            }
        }

        if (z2 != null)
        {
            if (t.z2 == null)
            {
                System.out.println("z2[] is null") ;
                return false ;
            }

            if (z2.length != t.z2.length)
            {
                System.out.println("z2.length error") ;
                return false ;
            }

            for (int i = 0 ; i < z2.length ; i++)
            {
                if (z2[i] != t.z2[i])
                {
                    System.out.println("z2[] error") ;
                    return false ;
                }
            }

        }
        else
        {
            if (t.z2 != null)
            {
                System.out.println("z2[] is not null") ;
                return false ;
            }
        }

        if (f2 != null)
        {
            if (t.f2 == null)
            {
                System.out.println("f2[] is null") ;
                return false ;
            }

            if (f2.length != t.f2.length)
            {
                System.out.println("f2.length error") ;
                return false ;
            }

            for (int i = 0 ; i < f2.length ; i++)
            {
                if (f2[i] != t.f2[i])
                {
                    System.out.println("f2[] error") ;
                    return false ;
                }
            }
        }
        else
        {
            if (t.f2 != null)
            {
                System.out.println("f2[] is not null") ;
                return false ;
            }
        }


        if (d2 != null)
        {
            if (t.d2 == null)
            {
                System.out.println("d2[] is null") ;
                return false ;
            }

            if (d2.length != t.d2.length)
            {
                System.out.println("d2.length error") ;
                return false ;
            }

            for (int i = 0 ; i < d2.length ; i++)
            {
                if (d2[i] != t.d2[i])
                {
                    System.out.println("d2[] error") ;
                    return false ;
                }
            }
        }
        else
        {
            if (t.d2 != null)
            {
                System.out.println("d2[] is not null") ;
                return false ;
            }
        }

        if (c2 != null)
        {
            if (t.c2 == null)
            {
                System.out.println("c2[] is null") ;
                return false ;
            }

            if (c2.length != t.c2.length)
            {
                System.out.println("c2.length error") ;
                return false ;
            }

            for (int i = 0 ; i < c2.length ; i++)
            {
                if (c2[i] != t.c2[i])
                {
                    System.out.println("c2[] error") ;
                    return false ;
                }
            }
        }
        else
        {
            if (t.c2 != null)
            {
                System.out.println("c2[] is not null") ;
                return false ;
            }
        }

        if (lInteger1 == null)
        {
            if (t.lInteger1 != null)
            {
                System.out.println("Integer not null") ;
                return false ;
            }
        }
        else
        {
            if (!lInteger1.equals(t.lInteger1))
            {
                System.out.println("Integer not equal") ;
                return false ;
            }
        }


        if (lLong1 == null)
        {
            if (t.lLong1 != null)
            {
                System.out.println("Long not null") ;
                return false ;
            }
        }
        else
        {
            if (!lLong1.equals(t.lLong1))
            {
                System.out.println("Long not equal") ;
                return false ;
            }
        }


        if (lBoolean1 == null)
        {
            if (t.lBoolean1 != null)
            {
                System.out.println("Boolean not null") ;
                return false ;
            }
        }
        else
        {
            if (!lBoolean1.equals(t.lBoolean1))
            {
                System.out.println("Boolean not equal") ;
                return false ;
            }
        }

        if (lFloat1 == null)
        {
            if (t.lFloat1 != null)
            {
                System.out.println("Float not null") ;
                return false ;
            }
        }
        else
        {
            if (!lFloat1.equals(t.lFloat1))
            {
                System.out.println("Float not equal") ;
                return false ;
            }
        }

        if (lDouble1 == null)
        {
            if (t.lDouble1 != null)
            {
                System.out.println("Double not null") ;
                return false ;
            }
        }
        else
        {
            if (!lDouble1.equals(t.lDouble1))
            {
                System.out.println("Double not equal") ;
                return false ;
            }
        }

        if (lCharacter1 == null)
        {
            if (t.lCharacter1 != null)
            {
                System.out.println("Character not null") ;
                return false ;
            }
        }
        else
        {
            if (!lCharacter1.equals(t.lCharacter1))
            {
                System.out.println("Character not equal") ;
                return false ;
            }
        }

        if (lString1 == null)
        {
            if (t.lString1 != null)
            {
                System.out.println("String not null") ;
                return false ;
            }
        }
        else
        {
            if (!lString1.equals(t.lString1))
            {
                System.out.println("String not equal") ;
                return false ;
            }
        }

        if (lDate1 == null)
        {
            if (t.lDate1 != null)
            {
                System.out.println("Date not null") ;
                return false ;
            }
        }
        else
        {
            if (!lDate1.equals(t.lDate1))
            {
                System.out.println("Date not equal") ;
                return false ;
            }
        }

        //

        if (lInteger2 == null)
        {
            if (t.lInteger2 != null)
            {
                System.out.println("Integer[] not null") ;
                return false ;
            }
        }
        else
        {
            if (lInteger2.length != t.lInteger2.length)
            {
                System.out.println("Integer2.length not equal") ;
                return false ;
            }

            for (int i = 0 ; i < lInteger2.length ; i++)
            {
                if (lInteger2[i] == null)
                {
                    if (t.lInteger2[i] != null)
                    {
                        System.out.println("Integer[] element not null") ;
                        return false ;
                    }
                }
                else
                {
                    if (!lInteger2[i].equals(t.lInteger2[i]))
                    {
                        System.out.println("Integer[] element not equals") ;
                        return false ;
                    }
                }

            }
        }

        //

        if (lLong2 == null)
        {
            if (t.lLong2 != null)
            {
                System.out.println("Long[] not null") ;
                return false ;
            }
        }
        else
        {
            if (lLong2.length != t.lLong2.length)
            {
                System.out.println("Long2.length not equal") ;
                return false ;
            }

            for (int i = 0 ; i < lLong2.length ; i++)
            {
                if (lLong2[i] == null)
                {
                    if (t.lLong2[i] != null)
                    {
                        System.out.println("Long[] element not null") ;
                        return false ;
                    }
                }
                else
                {
                    if (!lLong2[i].equals(t.lLong2[i]))
                    {
                        System.out.println("Long[] element not equals") ;
                        return false ;
                    }
                }

            }
        }

        //

        if (lBoolean2 == null)
        {
            if (t.lBoolean2 != null)
            {
                System.out.println("Boolean[] not null") ;
                return false ;
            }
        }
        else
        {
            if (lBoolean2.length != t.lBoolean2.length)
            {
                System.out.println("Boolean2.length not equal") ;
                return false ;
            }

            for (int i = 0 ; i < lBoolean2.length ; i++)
            {
                if (lBoolean2[i] == null)
                {
                    if (t.lBoolean2[i] != null)
                    {
                        System.out.println("Boolean[] element not null") ;
                        return false ;
                    }
                }
                else
                {
                    if (!lBoolean2[i].equals(t.lBoolean2[i]))
                    {
                        System.out.println("Boolean[] element not equals") ;
                        return false ;
                    }
                }

            }
        }

        //

        if (lFloat2 == null)
        {
            if (t.lFloat2 != null)
            {
                System.out.println("Float[] not null") ;
                return false ;
            }
        }
        else
        {
            if (lFloat2.length != t.lFloat2.length)
            {
                System.out.println("Float2.length not equal") ;
                return false ;
            }

            for (int i = 0 ; i < lFloat2.length ; i++)
            {
                if (lFloat2[i] == null)
                {
                    if (t.lFloat2[i] != null)
                    {
                        System.out.println("Float[] element not null") ;
                        return false ;
                    }
                }
                else
                {
                    if (!lFloat2[i].equals(t.lFloat2[i]))
                    {
                        System.out.println("Float[] element not equals") ;
                        return false ;
                    }
                }

            }
        }

        //

        if (lDouble2 == null)
        {
            if (t.lDouble2 != null)
            {
                System.out.println("Double[] not null") ;
                return false ;
            }
        }
        else
        {
            if (lDouble2.length != t.lDouble2.length)
            {
                System.out.println("Double2.length not equal") ;
                return false ;
            }

            for (int i = 0 ; i < lDouble2.length ; i++)
            {
                if (lDouble2[i] == null)
                {
                    if (t.lDouble2[i] != null)
                    {
                        System.out.println("Double[] element not null") ;
                        return false ;
                    }
                }
                else
                {
                    if (!lDouble2[i].equals(t.lDouble2[i]))
                    {
                        System.out.println("Double[] element not equals") ;
                        return false ;
                    }
                }

            }
        }

        //

        if (lCharacter2 == null)
        {
            if (t.lCharacter2 != null)
            {
                System.out.println("Character[] not null") ;
                return false ;
            }
        }
        else
        {
            if (lCharacter2.length != t.lCharacter2.length)
            {
                System.out.println("Character2.length not equal") ;
                return false ;
            }

            for (int i = 0 ; i < lCharacter2.length ; i++)
            {
                if (lCharacter2[i] == null)
                {
                    if (t.lCharacter2[i] != null)
                    {
                        System.out.println("Character[] element not null") ;
                        return false ;
                    }
                }
                else
                {
                    if (!lCharacter2[i].equals(t.lCharacter2[i]))
                    {
                        System.out.println("Character[] element not equals") ;
                        return false ;
                    }
                }

            }
        }

        //

        if (lString2 == null)
        {
            if (t.lString2 != null)
            {
                System.out.println("String[] not null") ;
                return false ;
            }
        }
        else
        {
            if (lString2.length != t.lString2.length)
            {
                System.out.println("String2.length not equal") ;
                return false ;
            }

            for (int i = 0 ; i < lString2.length ; i++)
            {
                if (lString2[i] == null)
                {
                    if (t.lString2[i] != null)
                    {
                        System.out.println("String[] element not null") ;
                        return false ;
                    }
                }
                else
                {
                    if (!lString2[i].equals(t.lString2[i]))
                    {
                        System.out.println("String[] element not equals") ;
                        return false ;
                    }
                }

            }
        }

        //

        if (lDate2 == null)
        {
            if (t.lDate2 != null)
            {
                System.out.println("Date[] not null") ;
                return false ;
            }
        }
        else
        {
            if (lDate2.length != t.lDate2.length)
            {
                System.out.println("Date2.length not equal") ;
                return false ;
            }

            for (int i = 0 ; i < lDate2.length ; i++)
            {
                if (lDate2[i] == null)
                {
                    if (t.lDate2[i] != null)
                    {
                        System.out.println("Date[] element not null") ;
                        return false ;
                    }
                }
                else
                {
                    if (!lDate2[i].equals(t.lDate2[i]))
                    {
                        System.out.println("Date[] element not equals") ;
                        return false ;
                    }
                }

            }
        }

        if (object1 == null)
        {
            if (t.object1 != null)
            {
                System.out.println("Referenced object not null (" + object1 + " " + t.object1 + ")") ;
                return false ;
            }
        }
        else
        {
            if (t.object1 == null)
            {
                System.out.println("Referenced object is null") ;
                return false ;
            }

            if (!object1.isEqual(t.object1))
            {
                System.out.println("Referenced objects not equals") ;
                return false ;
            }
        }

        if (object2 == null)
        {
            if (t.object2 != null)
            {
                System.out.println("Referenced object[] not null") ;
                return false ;
            }
        }
        else
        {
            if (t.object2 == null)
            {
                System.out.println("Referenced object[] is null") ;
                return false ;
            }

            if (object2.length != t.object2.length)
            {
                System.out.println("Referenced object[] length not equals") ;
                return false ;
            }

            for (int i = 0 ; i < object2.length ; i++)
            {
                if (object2[i] == null)
                {
                    if (t.object2[i] != null)
                    {
                        System.out.println("Referenced object[] element not null") ;
                        return false ;
                    }
                }
                else
                {
                    if (!object2[i].isEqual(t.object2[i]))
                    {
                        System.out.println("Referenced object[] element not equal") ;
                        return false ;
                    }
                }
            }
        }

        return true ;       // phew..
    }

    private void setMinimum()
    {
        b1 = (byte)-128 ;
        s1 = (short)-32768 ;
        i1 = Integer.MIN_VALUE ;
        j1 = Long.MIN_VALUE ;
        z1 = false ;
        f1 = Float.MIN_VALUE ;
        d1 = Double.MIN_VALUE ;
        c1 = Character.MIN_VALUE ;

        lInteger1 = new Integer(Integer.MIN_VALUE) ;
        lLong1 = new Long(Long.MIN_VALUE ) ;
        lBoolean1 = new Boolean(false) ;
        lFloat1 = new Float(Float.MIN_VALUE ) ;
        lDouble1 = new Double( Double.MIN_VALUE ) ;
        lCharacter1 = new Character( Character.MIN_VALUE) ;
        lString1 = new String() ;
        lDate1 = new Date( 70,0,1,12,0,0 ) ;
    }


    private void setMinimumArray(int size)
    {
        declareArray(size) ;

        for (int i = 0 ; i < size ; i++)
        {
            b2[i] = (byte)-128 ;
            s2[i] = -32768 ;
            i2[i] = Integer.MIN_VALUE ;
            j2[i] = Long.MIN_VALUE ;
            z2[i] = false ;
            f2[i] = Float.MIN_VALUE ;
            d2[i] = Double.MIN_VALUE ;
            c2[i] = Character.MIN_VALUE ;

            lInteger2[i] = new Integer(Integer.MIN_VALUE) ;
            lLong2[i] = new Long(Long.MIN_VALUE ) ;
            lBoolean2[i] = new Boolean(false) ;
            lFloat2[i] = new Float(Float.MIN_VALUE ) ;
            lDouble2[i] = new Double( Double.MIN_VALUE ) ;
            lCharacter2[i] = new Character( Character.MIN_VALUE) ;
            lString2[i] = new String() ;
            lDate2[i] = new Date( 70,0,2,22,0,0 ) ;
        }
    }

    private void setMaximum()
    {
        b1 = (byte)127 ;
        s1 = (short)32767 ;
        i1 = Integer.MAX_VALUE ;
        j1 = Long.MAX_VALUE ;
        z1 = false ;
        f1 = Float.MAX_VALUE ;
        d1 = Double.MAX_VALUE ;
        c1 = Character.MAX_VALUE ;

        lInteger1 = new Integer(Integer.MAX_VALUE) ;
        lLong1 = new Long(Long.MAX_VALUE ) ;
        lBoolean1 = new Boolean(false) ;
        lFloat1 = new Float(Float.MAX_VALUE ) ;
        lDouble1 = new Double( Double.MAX_VALUE ) ;
        lCharacter1 = new Character( Character.MAX_VALUE) ;
        lString1 = new String("ABCDEFGHIJKLMN") ;
        lDate1 = new Date( 99,11,31,23,59,59 ) ;
    }


    private void setMaximumArray(int size)
    {
        declareArray(size) ;

        for (int i = 0 ; i < size ; i++)
        {
            b2[i] = (byte)127 ;
            s2[i] = (short)32767 ;
            i2[i] = Integer.MAX_VALUE ;
            j2[i] = Long.MAX_VALUE ;
            z2[i] = false ;
            f2[i] = Float.MAX_VALUE ;
            d2[i] = Double.MAX_VALUE ;
            c2[i] = Character.MAX_VALUE ;

            lInteger2[i] = new Integer(Integer.MAX_VALUE) ;
            lLong2[i] = new Long(Long.MAX_VALUE ) ;
            lBoolean2[i] = new Boolean(false) ;
            lFloat2[i] = new Float(Float.MAX_VALUE ) ;
            lDouble2[i] = new Double( Double.MAX_VALUE ) ;
            lCharacter2[i] = new Character( Character.MAX_VALUE) ;
            lString2[i] = new String("ABCDEFGHIJKLMN") ;
            lDate2[i] = new Date( 99,11,31,23,59,59 ) ;
        }
    }

    private void setZero()
    {
        b1 = 0 ;
        s1 = 0 ;
        i1 = 0 ;
        j1 = 0 ;
        z1 = false ;
        f1 = 0 ;
        d1 = 0 ;
        c1 = 0 ;

        lInteger1 = new Integer(0) ;
        lLong1 = new Long(0) ;
        lBoolean1 = new Boolean(false) ;
        lFloat1 = new Float(0) ;
        lDouble1 = new Double(0) ;
        lCharacter1 = new Character('\0') ;
        lString1 = new String("") ;
        lDate1 = new Date( 70,0,1,12,0,0 ) ;
    }

    private void setNull()
    {
        b1 = 0 ;
        s1 = 0 ;
        i1 = 0 ;
        j1 = 0 ;
        z1 = false ;
        f1 = 0 ;
        d1 = 0 ;
        c1 = 0 ;

        lInteger1 = null ;
        lLong1 = null ;
        lBoolean1 = null ;
        lFloat1 = null ;
        lDouble1 = null ;
        lCharacter1 = null ;
        lString1 = null ;
        lDate1 = null ;
    }

    private void setNullArray(int size)
    {
        declareArray(size) ;

        for (int i = 0 ; i < size ; i++)
        {
            b2[i] = 0 ;
            s2[i] = 0 ;
            i2[i] = 0 ;
            j2[i] = 0 ;
            z2[i] = false ;
            f2[i] = 0 ;
            d2[i] = 0 ;
            c2[i] = 0 ;

            lInteger2[i] = null ;
            lLong2[i] = null ;
            lBoolean2[i] = null ;
            lFloat2[i] = null ;
            lDouble2[i] = null ;
            lCharacter2[i] = null ;
            lString2[i] = null ;
            lDate2[i] = null ;
        }
    }

    private void declareArray(int size)
    {
        b2 = new byte[size] ;
        s2 = new short[size] ;
        i2 = new int[size] ;
        j2 = new long[size] ;
        z2 = new boolean[size] ;
        f2 = new float[size] ;
        d2 = new double[size] ;
        c2 = new char[size] ;

        lInteger2 = new Integer[size] ;
        lLong2 = new Long[size] ;
        lBoolean2 = new Boolean[size] ;
        lFloat2 = new Float[size] ;
        lDouble2 = new Double[size] ;
        lCharacter2 = new Character[size] ;
        lString2 = new String[size] ;
        lDate2 = new Date[size] ;
    }
}

